poj 3071 Football (概率DP水题)

G - Football

Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%I64d & %I64u

Submit Status

Description

Consider a single-elimination football tournament involving 2n teams, denoted 1, 2, …, 2n. In each round of the tournament, all teams still in the tournament are placed in a list in order of increasing index. Then, the first team in the list plays the second team, the third team plays the fourth team, etc. The winners of these matches advance to the next round, and the losers are eliminated. After n rounds, only one team remains undefeated; this team is declared the winner.

Given a matrix P = [pij] such that pij is the probability that team i will beat team j in a match determine which team is most likely to win the tournament.

Input

The input test file will contain multiple test cases. Each test case will begin with a single line containing n (1 ≤ n ≤ 7). The next 2n lines each contain 2nvalues; here, the jth value on the ith line represents pij. The matrix P will satisfy the constraints that pij = 1.0 − pji for all i ≠ j, and pii = 0.0 for all i. The end-of-file is denoted by a single line containing the number −1. Note that each of the matrix entries in this problem is given as a floating-point value. To avoid precision problems, make sure that you use either the double data type instead of float.

Output

The output file should contain a single line for each test case indicating the number of the team most likely to win. To prevent floating-point precision issues, it is guaranteed that the difference in win probability for the top two teams will be at least 0.01.

Sample Input

2
0.0 0.1 0.2 0.3
0.9 0.0 0.4 0.5
0.8 0.6 0.0 0.6
0.7 0.5 0.4 0.0
-1

Sample Output

2

Hint

In the test case above, teams 1 and 2 and teams 3 and 4 play against each other in the first round; the winners of each match then play to determine the winner of the tournament. The probability that team 2 wins the tournament in this case is:

P(2 wins)  P(2 beats 1)P(3 beats 4)P(2 beats 3) + P(2 beats 1)P(4 beats 3)P(2 beats 4)
p21p34p23 + p21p43p24
= 0.9 · 0.6 · 0.4 + 0.9 · 0.4 · 0.5 = 0.396.

The next most likely team to win is team 3, with a 0.372 probability of winning the tournament.

题目:有2^n个队,相邻的两两打淘汰赛,,求最后哪个队夺冠的概率最大。

题解:dp[i][j]表示第i轮的时候,第j去支队伍赢的概率。那么dp[i][j]的前提就是i-1轮的时候,

   j是赢的,而且第i轮赢了对方接下来就是找到第i轮的时候,他的可能队手

   通过二进制可以发现规律,所有高位是一样的,第i位刚好相反,

   所以用位运算可以巧妙解决,见代码

   dp[i][j]=sigma(dp[i-1][j]*dp[i-1][k]*p[j][k])

   每经过一轮会淘汰掉一半的人,所以可以右移一位,即除以二求概率。

   具体的解释请看代码注释。O(∩_∩)O

#include <iostream>
#include <string.h>
using namespace std;
double dp[8][200];
double p[200][200];
int main()
{
    int n,ans;
    while(cin>>n)
    {
        if(n==-1)
            break;
        memset(dp,0,sizeof(dp));
        for(int i=0;i<(1<<n);i++)//2^n支队伍
        for(int j=0;j<(1<<n);j++)
        cin>>p[i][j];
        for(int i=0;i<(1<<n);i++)
        dp[0][i]=1;
        for(int i=1;i<=n;i++) //n次比赛
        for(int j=0;j<(1<<n);j++)//注意这里跑的核心是j 而且j只跑了一次
        for(int k=0;k<(1<<n);k++)//这里是左移 代表队伍数
        if(((j>>(i-1))^1)==(k>>(i-1))) //这里是右移 代表每次淘汰一半人
        //这个if的意思是奇数只和上一个数比而偶数只和下一个数比
        //异或一可以让奇数减一 偶数加一
        dp[i][j]+=dp[i-1][j]*dp[i-1][k]*p[j][k]; //别忘了加号 是把概率加起来
        double max=-1;
        /*for(int j=0;j<(1<<n);j++)
            cout<<dp[n][j]<<endl;*/ //输出各队胜率
        for(int j=0;j<(1<<n);j++) //选择胜率最高的那个队伍
        if(dp[n][j]>max)
        {
            max=dp[n][j];
            ans=j+1;
        }
        cout<<ans<<endl;
    }
    return 0;
}
时间: 2024-11-03 20:56:57

poj 3071 Football (概率DP水题)的相关文章

[ACM] POJ 3071 Football (概率DP)

Football Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 2875   Accepted: 1462 Description Consider a single-elimination football tournament involving 2n teams, denoted 1, 2, -, 2n. In each round of the tournament, all teams still in the

POJ 3071 Football (概率DP)

题意:给定 2的n次方 个团队对每个队的战胜的概率,一块要打 n 场,每场都是 1 对 2, 2 对 3,每次都取赢的一方,问你最后谁是冠军的概率最大. 析:dp[i][j] 表示 第 i 场 j 胜的概率,每次只要算 i 相邻的且不是已经打过的 2 i-1次方个队,最后再选出概率最大的就好. 代码如下: #pragma comment(linker, "/STACK:1024000000,1024000000") #include <cstdio> #include &l

Codeforces 148D 一袋老鼠 Bag of mice | 概率DP 水题

除非特别忙,我接下来会尽可能翻译我做的每道CF题的题面! Codeforces 148D 一袋老鼠 Bag of mice | 概率DP 水题 题面 胡小兔和司公子都认为对方是垃圾. 为了决出谁才是垃圾,大哥拿来了一袋老鼠,其中有w只白老鼠和b只黑老鼠.胡小兔先抓,先抓到白老鼠的人赢. 每次学姐抓完老鼠之后,总会有另外一只老鼠从袋子里自己跑出来(这只老鼠不算任何人抓的),而胡小兔抓老鼠时则不会发生这样的事. 每次袋子里的每只老鼠被抓到的概率相等,当有一只老鼠跑出来的时候,每只老鼠跑出来的几率也相

13年山东省赛 The number of steps(概率dp水题)

转载请注明出处: http://www.cnblogs.com/fraud/          ——by fraud The number of steps Time Limit: 1 Sec  Memory Limit: 128 M Description Mary stands in a strange maze, the maze looks like a triangle(the first layer have one room,the second layer have two ro

LightOJ1030 Discovering Gold 概率DP 水题

Time Limit:2000MS     Memory Limit:32768KB     64bit IO Format:%lld & %llu Description You are in a cave, a long cave! The cave can be represented by a 1 x N grid. Each cell of the cave can contain any amount of gold. Initially you are in position 1.

poj 3071 简单概率dp

题意很清晰,就是问最有可能获得冠军的队伍. 需要注意的是每轮比赛中,每个队都是和自己旁边的一个队比赛,采用淘汰赛制,所以需要决定第i轮的时候j队可以和哪些队比赛,然后求概率dp即可. 状态转移方程: dp[i][j] += dp[i - 1][j] * dp[i - 1][k] * p[j][k]; dp[i][j]表示第i轮j队获胜的概率 = 第i-1轮j队获胜的概率 * 第i-1轮k队获胜的概率 * j队打败k队的概率(之和). 前提是j和k在第i轮可能遇到. 判断方法: ( j >> (

hdu3722Card Game 概率dp水题

//3中天气前一天天气为i转为第二天天气为j的概率为p[i][j] //问第一天天气为i,n天后天气为j的概率 //dp[i][j][k]在第一天天气为j的情况下第n天的天气为j的概率 //dp[i][j][k] += dp[i-1][j][s]*dp[1][s][k] ; #include<cstdio> #include<cstring> #include<iostream> using namespace std ; const int maxn = 1010 ;

HDU 4576 Robot 概率DP 水题

Robot Time Limit: 8000/4000 MS (Java/Others)    Memory Limit: 102400/102400 K (Java/Others)Total Submission(s): 3851    Accepted Submission(s): 1246 Problem Description Michael has a telecontrol robot. One day he put the robot on a loop with n cells.

hdu4405Aeroplane chess 概率dp水题

//从0到n有n+1个格子 //对于格子i,掷一次骰子的数为x.那么能够从位置i到位置i+x //格子之间有连线,假设格子a和b有连线,那么从a到b不用掷骰子 //求从0到n的骰子掷的次数的期望 //dp[i] = 1/6*segma(dp[k]) + 1 (i<=k<=i+6) #include<cstdio> #include<iostream> #include<cstring> using namespace std ; const int maxn